#!/usr/bin/env coffee

__cli__ = require("commander")
__async__ = require("async")
__cp__ = require("child_process")
__path__ = require("path")
__colors__ = require("colors")

__cli__
	.version("0.0.7")
	.usage("-s [-n -p] | -t")
	.option("-t, --test", "Unit test project using Mocha")
	.option("-s, --start", "Start server using node (default to development mode)")
	.option("-p, --production", "Start server in deployment mode. (option of --start)")
	.option("-n, --nodemon", "Start server with nodemon instead.  (option of --start)")
	.parse(process.argv)

__cli__.help() if (!__cli__.start and !__cli__.test)

if __cli__.start
	__cli__.help() if (__cli__.test)

	__async__.series [ (callback) ->
		__cp__.spawn("npm", ['install'], {stdio: 'inherit'})
	, (callback) ->
		process.env.NODE_ENV = if __cli__.production then "production" else "development"
		server = __cp__.spawn((if __cli__.nodemon then 'nodemon' else 'node'), ['app.js'], {stdio: 'inherit'})
		server.on('exit', () ->
			process.exit(0)
		)
	]
else if __cli__.test
	test = __cp__.spawn('mocha', ['--recursive', 'tests', '-R', 'nyan'], {stdio: 'inherit'})
	test.on('exit', () ->
		process.exit(0)
	)
else __cli__.help()